#! /bin/sh
#
# makedata.sh
#
# Version:		@(#)unotlogger.sh  $Revision: 1.1.1.1 $  13-Feb-2005  s-fusa@i.kyushu-u.ac.jp
#

# USAGE
if [ $# = 0 ]; then
    echo "Usage: ./unotlogger.sh DATA [DATA...]"
    echo ""
    exit
fi

# MAKE
#RUN="make run"
RUN="./unot.sh"

# ARGUMENTS
OPT=""
MIN_SUP="10 07 05 04 03 02 01"

# OUTPUT
LANG=C
DATE=`date +%Y-%m%d`
LOGDIR="unot_log_${DATE}"

# USE `tee'
USETEE=1

if [ ! -d $LOGDIR ]; then
    mkdir $LOGDIR
fi

# EXECUTE
for j in $MIN_SUP; do
    for i in $*; do
        basename=`basename $i`
        outfile=${LOGDIR}/unot_${j}pct_${basename}_${DATE}.log

        cat <<EOF > ${outfile}
======================================================================
 Date:           `date`
 Data File:      $basename
 Data Size:      `wc -c $i | awk '{print $1}'` [byte]
 Min-Support:    ${j}%
======================================================================

EOF
        echo "date:" `date`
        echo "$RUN $OPT $j $i > $outfile"
        if [ $USETEE ]; then
            $RUN $OPT $j $i 2>&1 | tee -a $outfile
        else
            $RUN $OPT $j $i >> $outfile 2>&1
        fi
        echo ""
    done
    echo ""
done
