package unot;

import java.io.*;
import java.util.*;

/** 
 * ҥΡɥꥹȷϥեѤιɤ߹ߥ롼Υ饹.
 */
class ChildFormatLineReader extends LineReader {

	final String signature = "ChildFormatLineReader";

// 	/** 饹⤫黲Ȥȡʥ */
// 	private StreamTokenizer st;
// 	private DocSet docset;

	public ChildFormatLineReader(DocSet docset, StreamTokenizer st) {
		super(docset, st);
	}

	String getSignature() { return signature; };
		
	/**
	 * ΡɹԤ򣱹ɤ߹ǥǡ򹹿롥
	 *
	 * @exception IOException if an error occurs
	 */
	public UnotNode readNodeLine() throws IOException
	{
		DocSet.NodeDict nodeDict = this.docset.getNodeDict();
		UnotNode node;

		// Ρֹ椫 lookupNode ǥΡɤʸ
		if (st.ttype == StreamTokenizer.TT_NUMBER) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, "@log Lookup_Node: " + (int) st.nval);
			node = (UnotNode) nodeDict.lookupNode((int) st.nval);
		} else throw new IOException("A number token expected at self node position: "+"\""+st.sval+"\"");

		// ٥ʸ󤫤 lookupId ǥ٥ ID Ϳ
		if (st.nextToken() == StreamTokenizer.TT_WORD) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, " " + st.sval);
			DocSet.LabelDict labelDict = this.docset.getLabelDict();
			node.setLabelId(labelDict.lookupId(st.sval));
		} else throw new IOException("A word token expected at node label position: "+"\""+st.sval+"\"");

		// ޤǥΡɤܥꥹȤ
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO, " ");

		//removed by arim on 041224:
		//-  UnotNode.addChildAtLast() Τס
		//NodeList children = node.getChildren(); // Adjacency List Representation
		UnotNode head = null;               // LeftMostChild NextSibling Representation

		while ((st.nextToken() != StreamTokenizer.TT_EOL)
			   && (st.ttype != StreamTokenizer.TT_EOF)) {

			if (st.ttype != StreamTokenizer.TT_NUMBER)
				throw new IOException("A number token expected at child node position: "+"\""+st.sval+"\"");

			// Ρֹ椫 lookupNode ǥΡɤ򸡺
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, (int) st.nval + " ");
			UnotNode child = nodeDict.lookupNode((int) st.nval);
			child.setParent(node);

			if (DocSet.useAdjacencyList) {
				node.addChildAtLast(child);
				//children.add(child); //removed by arim
			} else {
				if (head == null) node.setLeftMostChild(child);
				else head.setNextSibling(child);
				head = child;
			}
		}

		//removed by arim. UnotNode On demand ˤΤǤ
		//if (DocSet.useAdjacencyList) {
		//	node.setChildren(children); // ܥꥹȤ򹹿
		//}
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO, "\n");

		if (node == null)
			throw new IOException();
		return node;
	}
} // ChildFormatLineReader

//EOF
