/*
 * @(#)NodeList.java
 *
 * Copyright 2003, Tatsuya Asai, Hiroki Arimura, Takeaki Uno,
 * and Shin-ichi Nakano, all rights reserved.
 *
 * This file contains an implementation of the algorithm "UNOT".
 *
 * @see Discovering Frequent Substructures in Large Unordered Trees,
 * In Proc. the 6th Discovery Science (DS'03), LNAI, October 2003.
 * <http://www.i.kyushu-u.ac.jp/doitr/trcs216.pdf>
 *
 * This software may be used freely for any purpose. However, when distributed,
 * the original source must be clearly stated, and, when the source code is
 * distributed, the copiright notice must be retained and any alterations in
 * the code must be clearly marked. No warranty is given regarding the quality
 * of this software.
 */
package unot;

import java.util.ArrayList;

/**
 * A list of data tree nodes. 
 * NodeList.java
 * Created: Fri Aug 29 16:15:52 2003
 *
 * @author <a href="mailto:s-fusa@i.kyushu-u.ac.jp">Shinji Fusanobu</a>
 * @version $Revision: 1.3 $
 */
public class NodeList extends ArrayList<UnotNode>
{
	/** $B%N!<%I%j%9%H$N=PNO$r$9$k:]$K!$:9J,%j%9%H7A<0$G$"$i$o$9$+$r$"$i$o$9JQ?t!%(B */
	static boolean useDiffString = false; 

	/** Not Used  */
	public ArrayList<Integer> getNodeIdList() {
		ArrayList<Integer> idlist = new ArrayList<Integer>(); 
		for (int i = 0; i < this.size(); i++) {
			UnotNode node = this.get(i);
			idlist.add(new Integer(node.getNodeId()));
		}
		return idlist; 
	}

	public String getNodeIdListString() {
		StringBuffer strBuf = new StringBuffer();
		int val; 
		int last = 0; 
		for (int i = 0; i < this.size(); i++) {
			UnotNode node = (UnotNode) this.get(i);
			int id = val = node.getNodeId();
			if (useDiffString)
				val = val - last; 
			strBuf.append(val+" ");
			last = id; 
		}
		return strBuf.toString(); 
	}

} // NodeList
