package unot;

public class ParentPatternWriter extends PatternWriter {
	public static final String signature = "parent";
	static final String writerName = signature+" ParentPatternWriter [id parentid labelid labelString]";

	static final int GRAND_ROOT_ID = -1;

	DocSet docSet = null;

	public ParentPatternWriter(DocSet docSet) {
		if (docSet == null) {
			System.out.println("error: UnotPatternWriter:null docSet!");
			System.exit(1);
		}
		this.docSet = docSet;
	};

	public String getName() { return writerName; }

	String writeTree(Pattern pattern) {
		StringBuffer strBuf = new StringBuffer();

		StackList nodeStack = new StackList();
		nodeStack.push(new Integer(GRAND_ROOT_ID));

		for (int id = 0; id < pattern.getCodeSize(); id++) {
			Integer parentId = (Integer)nodeStack.getTop();
			int     depth = pattern.getNodeAt(id).getDepth();
			int     label = pattern.getNodeAt(id).getLabel();
			String  labelString = this.docSet.lookupLabelById(label);
			nodeStack.push(new Integer(id));
			putIndent(strBuf, depth);
			//strBuf.append(id+" "+parentId+" "+label+" "+labelString+"\n");
			strBuf.append(id+" "+parentId+" "+labelString+"\n");
		}

		return strBuf.toString();
	}
}


//EOF 

